class MonsterIntro extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      if (lastActorName() == "monster") textBox("You remain in the "+monster.biome_name+" of the "+monster.race_name+" "+monster.actor_name+".");
      else textBox("You find yourself in the "+monster.biome_name+" of the "+monster.race_name+" "+monster.actor_name+".");
      finished = true;
    }
    if (finished) {
      if (!monster.dead && !player.special_hug_obtained && !monster.hugged) monster.nextDialogue = new MonsterAttacks();
      else if (!monster.dead && !monster.hugged && player.special_hug_obtained) monster.nextDialogue = new PlayerHugsMonster();
      else if (monster.hugged) monster.nextDialogue = new PlayerScreamsIntoVoid();
      else if (monster.dead) monster.nextDialogue = new MonstersBodyLiesOnGround();
    }
  }
}


class MonstersBodyLiesOnGround extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The monster's body lies rotting on the ground.");
      finished = true;
    }
    if (finished) {
      if (player.special_hug_obtained == true) monster.nextDialogue = new PlayerHugsMonstersCorpse();
      else {
        if (nextActorName() == "monster") monster.nextDialogue = new PlayerAdmiresOwnHandiwork();
        else monster.nextDialogue = new PlayerReflectsOnOwnHeroism();
      }
    }
  }
}


class PlayerReflectsOnOwnHeroism extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("After spending some time reflecting on your incredible heroism and remarkable good looks, you decide to move on.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerAdmiresOwnHandiwork extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You decide to stay a bit longer to admire your handiwork.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}

class PlayerHugsMonstersCorpse extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You activate your Special Hug ability!");
    if (line_index == 1) {
      textBox("You bend down and wrap your arms around the corpse, covering it in a warm embrace!");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "monster") monster.nextDialogue = new PlayerWondersWhyHeDidThat();
      else monster.nextDialogue = new PlayerHopesNoOneSaw();
    }
  }
}


class PlayerHopesNoOneSaw extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Nothing happens. You leave quickly, hoping no one saw what you just did.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}



class PlayerWondersWhyHeDidThat extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Nothing happens. You stay and wonder why you did that.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerScreamsIntoVoid extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("There is no one here.");
    if (line_index == 1) {
      textBox("The emptiness fills you with rage! You scream unintelligibly into the void.");
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "monster") monster.nextDialogue = new PlayerScreamsForLongTime();
      else monster.nextDialogue = new PlayerIsSatisfiedAndLeaves();
    }
  }
}


class PlayerIsSatisfiedAndLeaves extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("Satisfied, you turn around and leave.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerScreamsForLongTime extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You hang out and keep screaming for a weirdly long time.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerHugsMonster extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The "+monster.race_name+" monster seems ready to attack!");
    if (line_index == 1) textBox("But before it makes a move, you rush in and use your Special Hug!");
    if (line_index == 2) textBox("The monster seems confused at first, but then its demeanor softens. A single tear falls from its eye.");
    if (line_index == 3) textBox("The monster speaks:");
    if (line_index == 4) textBox("'Thank you, kind human. I know that I project an air of aggression, but that's really just my way of reaching out for help. You're the only one who has ever cared enough to love me!'");
    if (line_index == 5) textBox("'Please, take this as a token of my appreciation... I don't need it anymore.'");
    if (line_index == 6) textBox("The monster takes something off of its head and throws it to you! It then turns around and walks dramatically into the sunset.");
    if (line_index == 7) textBox("You look at what you now hold in your hand. It's the Helm of Monstrous Rage, a Legendary Artifact! You place it on your head.");
    if (line_index == 8) {
      textBox("Suddenly all your thoughts begin to be overtaken by a blind and murderous rage!");
      monster.hugged = true;
    }
    if (line_index == 9) {
      textBox("Your last thought before you are transformed into a violent and irrational psychopath is that perhaps this wasn't such a good idea.");
      player.helm_obtained = true;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "monster") monster.nextDialogue = new PlayerPunchesDirt();
      else monster.nextDialogue = new PlayerMakesOddGruntingNoises();
    }
  }
}


class PlayerPunchesDirt extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You notice the dirt below your feet. Something about it makes you incredibly angry!");
    if (line_index == 1) textBox("You squat and begin punching the ground, making angry growls each time you throw your fist.");
    if (line_index == 2) {
      textBox("You remain in this position for quite some time.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerMakesOddGruntingNoises extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You run off, making a series of odd grunting noises as you go.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class MonsterAttacks extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The " +monster.race_name+ " monster lunges in to attack!");
      player.apply_damage = true;
      monster.apply_damage = true;
    }
    if (line_index == 1) textBox("After the ensuing battle, you have "+player.health+" health points.");
    if (line_index == 2) {
      textBox("The monster has "+monster.health+" health points.");
      finished = true;
    }
    if (finished) {
      if (player.health <= 0) monster.nextDialogue = new MonsterKillsPlayer();
      else if (monster.health <= 0) monster.nextDialogue = new PlayerKillsMonster();
      else {
        if (nextActorName() == "monster") monster.nextDialogue = new PlayerContinuesToFight();
        else monster.nextDialogue = new PlayerRunsAway();
      }
    }
  }
}


class PlayerContinuesToFight extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You decide to stay and continue fighting.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerRunsAway extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You run away.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class MonsterKillsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You have died!");
      finished = true;
    }
    if (finished) player.dead = true;
  }
}


class PlayerKillsMonster extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You've slain the monster!");
      monster.dead = true;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "monster") monster.nextDialogue = new PlayerEnjoysVictory();
      else monster.nextDialogue = new PlayerRunsOffIntoDistance();
    }
  }
}


class PlayerRunsOffIntoDistance extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You run off into the distance, excited to tell everyone about how great you are!");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}


class PlayerEnjoysVictory extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You decide to stay for a while and enjoy the feeling of victory.");
      finished = true;
    }
    if (finished) monster.scene_finished = true;
  }
}
