class WizardIntro extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      if (lastActorName() == "wizard") textBox("You remain in the "+wizard.biome_name+" of the "+wizard.race_name+" "+wizard.actor_name+".");
      else textBox("You find yourself in the "+wizard.biome_name+" of the "+wizard.race_name+" "+wizard.actor_name+".");
      finished = true;
    }

    if (finished) {
      if (wizard.first_encounter && !player.cookie_obtained && !player.helm_obtained && !player.special_hug_obtained && wizard.annoyance_level == 0) wizard.nextDialogue = new WizardFirstEncounter();
      else if (!wizard.dead && !wizard.first_encounter && player.helm_obtained) wizard.nextDialogue = new WhosAnnoyingNow();
      else if (wizard.dead) wizard.nextDialogue = new FlyHoversInAir();
      else if (!wizard.dead && player.special_hug_obtained && !player.helm_obtained && !wizard.hugged) wizard.nextDialogue = new PlayerHugsWizard();
      else if (!wizard.dead && wizard.annoyance_level == 1 && !player.helm_obtained && !player.cookie_obtained && !wizard.hugged) wizard.nextDialogue = new PlayerAnnoysWizard();
      else if (!wizard.dead && wizard.annoyance_level == 2 && !player.helm_obtained && !player.cookie_obtained && !wizard.hugged && wizard.health == 1) wizard.nextDialogue = new WizardWantsToFightAgain();
      else if (!wizard.dead && wizard.annoyance_level == 2 && !player.helm_obtained && !player.cookie_obtained && !wizard.hugged) wizard.nextDialogue = new WizardWantsToFight();
      else if (!wizard.dead && wizard.first_encounter && player.helm_obtained) wizard.nextDialogue = new BloodCurdlingScream();
      else if (!wizard.dead && player.cookie_obtained && !player.helm_obtained) wizard.nextDialogue = new WizardTakesCookie();
      else if (!wizard.dead && wizard.hugged && !player.helm_obtained) wizard.nextDialogue = new WizardIsInLove();
    }
  }
}


class WizardTakesCookie extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("As soon as you enter, the wizard notices the Delicious Cookie that you carry in your inventory.");
    if (line_index == 1) textBox("The wizard speaks:");
    if (line_index == 2) {
      if (wizard.hugged) textBox("'Dearest one! Thou hast brought a token of our love! How didst thou know I had a taste for sweets?'");
      else textBox("'Ah! I have always had a taste for sweets! Give me that cookie and I shall reward you greatly!");
    }
    if (line_index == 3) textBox("Before you have time to reply, the wizard levitates a chunk of the cookie out of your inventory and into his hand.");
    if (line_index == 4) textBox("The wizard gulps down the cookie with a series of sickening slurps. At first he seems very satisfied, but then his eyes bulge and his skin turns pale.");
    if (line_index == 5) textBox("The wizard speaks:");
    if (line_index == 6) textBox("'Argh! Didst yon cookies contain hazelnuts?! I doth possess severe nut allgeries! Why was there not a warning label?!'");
    if (line_index == 7) {
      textBox("'Thou hast killed me! Foul knave! I shall curse you with the blackest of hexes!'");
      finished = true;
    }
    if (finished) wizard.nextDialogue = new WizardCursesPlayer();
  }
}



class WizardIsInLove extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The wizard speaks:");
    if (line_index == 1) {
      if (lastActorName() == "wizard") textBox("'Tis wondrous to spend time with you, dearest one.'");
      else textBox("'Ah, 'tis you! The embrace we shared hast never left my mind!'");
    }
    if (line_index == 2) {
      if (nextActorName() == "wizard") textBox("You stay and give the wizard a hug- more out of pity than anything else.");
      else textBox("You leave quickly, hoping the wizard can take a hint.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class PlayerHugsWizard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Before the wizard can say a word, you activate your Special Hug power.");
    if (line_index == 1) textBox("You reach out and ensnare the wizard in an almost inhumanly warm embrace.");
    if (line_index == 2) textBox("You feel the wizard's demeanor soften almost instantly. You let him out of your arms and he brings his eyes up to gaze into yours.");
    if (line_index == 3) textBox("You start to pick up a weird vibe from him.");
    if (line_index == 4) textBox("The wizard speaks:");
    if (line_index == 5) textBox("'None before thou hast shown me such tenderness. Mine heart does swell with such emotion as I have never felt before. Wist thou take this gift as a token of mine love?");
    if (line_index == 6) {
      textBox("The wizard hands you a magical amulet. Your attacks will now deal 3 damage!");
      player.attack_power = 3;
      wizard.hugged = true;
    }
    if (line_index == 7) textBox("You thank the wizard and he gazes at you lovingly.");
    if (line_index == 8) {
      if (nextActorName() == "wizard") textBox("It's a bit creepy but you stay, hoping he'll provide you with more magical items.");
      else textBox("You hope he didn't get the wrong idea. You make an excuse and leave hastily.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class WizardWantsToFightAgain extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The wizard is still angry! You get ready for another fight.");
      finished = true;
    }
    if (finished) wizard.nextDialogue = new PlayerFightsWizard();
  }
}


class WizardWantsToFight extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The wizard speaks:");
    if (line_index == 1) textBox("'So be it. Mine patience is an end. Feel the wrath of my dark power!");
    if (line_index == 2) {
      textBox("Uh oh. You really did it this time! You ready yourself for the coming fight.");
      finished = true;
    }
    if (finished) wizard.nextDialogue = new PlayerFightsWizard();
  }
}


class PlayerAnnoysWizard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      if (lastActorName() == "wizard") textBox("Art thou still here?");
      else textBox("Hast thou returned, annoying one?");
    }
    if (line_index == 1) textBox("'Thou art testing my patience! If it is power you seek, then take this magical trinket and begone!'");
    if (line_index == 2) textBox("'But returneth not, or I shall gladly supply the painful death which you so seem to desire.'");
    if (line_index == 3) {
      textBox("Wow! The wizard tossed you a magical sword! You will now do twice as much damage with each attack!");
      player.attack_power = 2;
      wizard.annoyance_level = 2;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "wizard") wizard.nextDialogue = new PlayerMakesWeirdNoisesInWizardsEar();
      else wizard.nextDialogue = new PlayerIsAnAnnoyingBastard();
    }
  }
}


class PlayerIsAnAnnoyingBastard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("People always said you could be an annoying bastard, but you never thought being irritating could pay so well!");
    if (line_index == 1) {
      textBox("You run off clutching your new sword to your chest and giggling maniacally.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class PlayerMakesWeirdNoisesInWizardsEar extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Did the wizard really just give you a prize for being irritating?");
    if (line_index == 1) textBox("You think that maybe if you do some more dumb stuff he'll give you something else.");
    if (line_index == 2) {
      textBox("You sidle up next to him and start making weird noises in his ear.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class FlyHoversInAir extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The wizard's corpse lies crumpled up on the floor. It's starting to smell a little bit. A fly hovers in the air.");
      finished = true;
    }
    if (finished) {
      if (!player.helm_obtained) wizard.nextDialogue = new PlayerPokesCorpseWithStick();
      else wizard.nextDialogue = new PlayerSmashesFly();
    }
  }
}


class PlayerSmashesFly extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You roar and smash the fly between your fists.");
    if (line_index == 1) {
      if (nextActorName() == "wizard") textBox("You then start swatting wildly at all the other flies, as well as at anything else within arm's reach.");
      else textBox("Satisfied, you turn around and stomp away.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class PlayerPokesCorpseWithStick extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You poke the corpse with a stick and wait to see if anyting happens.");
    if (line_index == 1) {
      if (nextActorName() == "wizard") textBox("Nothing does, but keep waiting anyway.");
      else textBox("Nothing does. You decide to leave before your gag reflexes fully kick in.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class BloodCurdlingScream extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You see a "+wizard.race_name+" wizard standing in front of you. The helm's effects take hold!");
    if (line_index == 1) {
      textBox("You let out a blood-curdling scream and start flailing your arms wildly. The fight is on!");
      finished = true;
    }
    if (finished) wizard.nextDialogue = new PlayerFightsWizard();
  }
}



class WhosAnnoyingNow extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("It's the "+wizard.race_name+" wizard. The helm's effects take hold!");
    if (line_index == 1) {
      textBox("'Who's annoying now?!' you yell as you run forward brandishing your weapon.");
      player.apply_damage = true;
      wizard.apply_damage = true;
      finished = true;
    }
    if (finished) wizard.nextDialogue = new PlayerFightsWizard();
  }
}


class PlayerFightsWizard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("The wizard fires plumes of magic your way. You retaliate with your sword!");
      player.apply_damage = true;
      wizard.apply_damage = true;
    }
    if (line_index == 1) textBox("After the ensuing fight you have "+player.health+" health points.");
    if (line_index == 2) {
      textBox("The wizard has "+wizard.health+" health points.");
      finished = true;
    }
    if (finished) {
      if (player.health <= 0) wizard.nextDialogue = new WizardKillsPlayer();
      else if (wizard.health <= 0) wizard.nextDialogue = new PlayerKillsWizard();
      else {
        if (nextActorName() == "wizard") wizard.scene_finished = true;
        else wizard.nextDialogue = new PlayerRunsAwayFromWizard();
      }
    }
  }
}


class PlayerRunsAwayFromWizard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You run away.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class PlayerKillsWizard extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("You have dealt the wizard a mortal blow!");
    if (line_index == 1) textBox("The wizard falls to his knees, the life seeping out of him. But before he dies, he raises his eyes to meet yours and speaks:");
    if (line_index == 2) {
      textBox("'Fool! Didst thou think that thou could kill such a powerful being with no consequenses to thineself!");
      finished = true;
    }
    if (finished) wizard.nextDialogue = new WizardCursesPlayer();
  }
}


class WizardCursesPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The wizard reaches into his robes and pulls out a dagger carved with evil-looking desings.");
    if (line_index == 1) textBox("He brings the dagger to his wrist and cuts into it deeply, letting a torrent of blood spill onto an arcane seal carved into the ground.");
    if (line_index == 2) textBox("His eyes turn pitch black and he mutters several syllables in a forgotten tongue before finally dying.");
    if (line_index == 3) {
      textBox("You're sure it's nothing to worry about.");
      player.cursed = true;
      wizard.dead = true;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "wizard") wizard.nextDialogue = new PlayerMakesSureWizardIsDead();
      else wizard.nextDialogue = new PlayerStepsOverWizardsBody();
    }
  }
}


class PlayerStepsOverWizardsBody extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You step over the wizard's body and make for the door.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class PlayerMakesSureWizardIsDead extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("But just in case, you wait to make sure the old man is truly dead.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class WizardKillsPlayer extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("You have died!");
      finished = true;
    }
    if (finished) player.dead = true;
  }
}


class WizardFirstEncounter extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("The wizard speaks:");
    if (line_index == 1) textBox("'Who doth enter my "+wizard.biome_name+" and interrupt my ancient "+wizard.race_name+" magicks?'");
    if (line_index == 2) {
      textBox("'Leave, intruder, lest ye be the target of my next spell!'");
      wizard.first_encounter = false;
      wizard.annoyance_level = 1;
      finished = true;
    }
    if (finished) {
      if (nextActorName() == "wizard") wizard.nextDialogue = new MorbidSenseOfCuriosity();
      else wizard.nextDialogue = new PlayerLeavesWizardAloneForTimeBeing();
    }
  }
}


class PlayerLeavesWizardAloneForTimeBeing extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) textBox("Perhaps it would be best to leave the wizard alone for the time being.");
    if (line_index == 1) {
      textBox("You decide to head somewhere else.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}


class MorbidSenseOfCuriosity extends Dialogue {
  void display(int line_index_)
  {
    super.display(line_index_);
    if (line_index == 0) {
      textBox("He seems pretty angry, but your morbid sense of curiosity compels you to stay a bit longer.");
      finished = true;
    }
    if (finished) wizard.scene_finished = true;
  }
}
