class Actor {
  PShape actorShape;
  PImage backgroundImage;

  // The name of the region where this actor lives, and his/her name & race
  String biome_name, actor_name, race_name;
  
  int health;
  int attack_power;

  Dialogue currentDialogue, nextDialogue;

  // A string list which holds the dialogue which is currently being progressed through
  int[] line_order;

  // Keeping track of the current dialogue
  int dialogue_index, line_index;

  boolean dialogue_finished, scene_finished;
  boolean first_encounter;
  boolean end_first_encounter;
  
  boolean apply_damage;

  boolean dead;

  Actor(String race_name_, String biome_name_) {
    actorShape = loadShape(race_name_+ ".svg");
    backgroundImage = loadImage(biome_name_+ ".jpg");
    
    health = 1;
    attack_power = 1;

    race_name = race_name_;
    biome_name = biome_name_;
    
    first_encounter = true;

    dialogue_index = 0;
    line_index = 0;
  }

  void display() {
    shapeMode(CENTER);
    // Draw background
    image(backgroundImage, 0, 0);
    // Draw text box
    fill(0);
    rectMode(CORNER);
    rect(0, 400, width, height);
  }

  void action() {
    
    if (currentDialogue != null) {
      currentDialogue.display(line_index);

      // Check if the current dialogue is finished
      if (currentDialogue.finished == true) {
        dialogue_finished = true;
      }
    }
  }
  
  void reset() {
  }
}
